function [A, B] = Matrices(u, params)

Nxi = params.geometry.Nxi ;
dxi = params.geometry.dxi ;
velocity = params.data.velocity ;
mu = params.data.diffusionParam ;

A1diag = [-ones(Nxi-2,1) zeros(Nxi-2,1) ones(Nxi-2,1)];
A1diag(end,2) = 1 ;
A1 = -(0.5*velocity/dxi)*spdiags(A1diag, [-1 0 1], Nxi-2, Nxi-2) ;

A2diag = [ones(Nxi-2,1) -2*ones(Nxi-2,1) ones(Nxi-2,1)];
A2diag(end,2) = -1 ;
A2 = (1/dxi^2)*spdiags(A2diag, [-1 0 1], Nxi-2, Nxi-2) ;

A = A1+mu*A2 ;

B = zeros(Nxi-2, 1) ;
B(1) = 0.5*velocity/dxi+mu/dxi^2 ;