function [qsSimulated, params] = advectionDiffusionSimulated(params)

Nxi      = params.geometry.Nxi  ;
L = params.geometry.L ;

dxi = L/(Nxi-1)       ;
xi  = dxi*(0:1:Nxi-1) ; 

dt = params.time.dt ;

nTimeSteps = ceil(params.time.endTime/dt-1e-7)+1 ;
t = dt*(0:1:nTimeSteps-1) ;
endTime = t(end) ;
params.time.dt = dt ;
params.geometry.dxi = dxi ;
params.time.nTimeSteps = nTimeSteps ;

u0        = @(x)params.data.IC.amplitude*(exp(-(x-L*params.data.IC.relativeStartingPoint).^2/(params.data.IC.relativeStandardDerivation*L)^2)) ;

b = params.data.BC.startingPoint ;
c = (params.data.BC.relativeStandardDerivation*endTime)^2 ;
g = @(t)params.data.BC.amplitude*(exp(-(t-b).^2/c)) ;
params.data.BC.g = g ;

initialValue = u0(xi(2:end-1))' ;

params.simulation.timeIntegrator = @implTrapezoidalRule ;
qsSimulated = params.simulation.timeIntegrator(params, initialValue, t, @(x)Matrices(x,params)) ;