restoredefaultpath
clear
close all
warning('off', 'MATLAB:MKDIR:DirectoryExists');
clc

figureToCreate = 'PODVariousDiscretizations' ; % 'FOMsolution', 'PODVariousDiscretizations', 'ROMsolution'

params.dataName{1} = NaN ;
params.nModes = NaN ;
params.sPOD.startValue = 'naiveDecomposition' ;
params.loadPsiFrom = NaN ;

switch figureToCreate
    case 'FOMsolution'
        params.Nxi = 801 ;
        params.plot.showPlots = 'solution' ;
        create_example_func(true, false, params) ;
    case 'PODVariousDiscretizations'
        Nxi = [201, 401, 801, 1601] ;
        nNxis = length(Nxi) ;
        r = 1:35 ;
        nrs = length(r) ;
        offlineError = NaN(nNxis, nrs) ;
        onlineError = NaN(nNxis, nrs) ;
        fileNamePOD = cell(nNxis, nrs) ;
        params.modeDecomp.method = 'POD' ;
        figure
        hold on
        Legend = cell(2*nNxis, 1) ;
        xlabel('r')
        ylabel('error')
        set(gca, 'YScale', 'log')
        tic
        for i=1:nNxis
            params.Nxi = Nxi(i) ;
            params.ADE.projectionMode = 'off' ;
            fileNameADE = ['./sPOD/DATA/advectionDiffusion/',datestr(date,'yyyy-mm-dd'),'_Nxi',num2str(Nxi(i))] ;
            create_example_func(true, false, params, fileNameADE) ;
            params.dataName{1} = fileNameADE ;
            for j=1:nrs
                params.nModes = r(j) ;
                fileNamePOD{i,j} = ['./advectionDiffusionEq/DATA/PODmodes_', datestr(date,'yyyy-mm-dd'),'_Nxi', num2str(Nxi(i)), '_r', num2str(r(j))] ;
                offlineError(i,j) = create_example_func(false, true, params, fileNamePOD{i,j}) ;
                params.ADE.projectionMode = 'PODROM' ;
                params.modeFile = fileNamePOD{i,j} ;
                params.referenceSolution = fileNameADE ;
                onlineError(i,j) = create_example_func(true, false, params) ;
            end
            semilogy(r,offlineError(i,:), '--')
            Legend{(i-1)*2+1} = ['Nxi=', num2str(Nxi(i)), '-offline'] ;
            semilogy(r,onlineError(i,:))
            Legend{(i-1)*2+2} = ['Nxi=', num2str(Nxi(i)), '-online'] ;
            drawnow
            status2 = mkdir('sPOD','RESULTS') ;
            savefig(['./sPOD/RESULTS/fig_',datestr(date,'yyyy-mm-dd')])
            save(['./sPOD/RESULTS/data_',datestr(date,'yyyy-mm-dd')], 'Nxi', 'r', 'offlineError', 'onlineError')
        end
        simulationTime = toc ;
        legend(Legend) ;
    case 'ROMsolution'
        Nxi = 801 ;
        params.Nxi = Nxi ;
        r = 4 ;
        fileNameADE = ['./sPOD/DATA/advectionDiffusion/',datestr(date,'yyyy-mm-dd'),'_Nxi',num2str(Nxi)] ;
        create_example_func(true, false, params, fileNameADE) ;
        params.dataName{1} = fileNameADE ;
        params.nModes = r ;
        fileNameSPOD = ['./advectionDiffusionEq/DATA/sPODmodes_', datestr(date,'yyyy-mm-dd'),'_Nxi', num2str(Nxi), '_r', num2str(r)] ;
        if(~isfile([fileNameSPOD,'.mat']))
            offlineError = create_example_func(false, true, params, fileNameSPOD) ;
        end
        params.ADE.projectionMode = 'sPODROM' ;
        params.modeFile = fileNameSPOD ;
        params.referenceSolution = fileNameADE ;
        params.plot.showPlots = 'error' ;
        onlineError = create_example_func(true, false, params) ;
    case 'sPODVariousDiscretizations'
        Nxi = [201, 401, 801, 1601] ;
        nNxis = length(Nxi) ;
        r = 1:5 ;
        nrs = length(r) ;
        offlineError = NaN(nNxis, nrs) ;
        onlineError = NaN(nNxis, nrs) ;
        fileNameSPOD = cell(nNxis, nrs) ;
        figure
        hold on
        Legend = cell(2*nNxis, 1) ;
        xlabel('r')
        ylabel('error')
        set(gca, 'YScale', 'log')
        tic
        for i=1:nNxis
            params.Nxi = Nxi(i) ;
            params.ADE.projectionMode = 'off' ;
            fileNameADE = ['./sPOD/DATA/advectionDiffusion/',datestr(date,'yyyy-mm-dd'),'_Nxi',num2str(Nxi(i))] ;
            create_example_func(true, false, params, fileNameADE) ;
            params.dataName{1} = fileNameADE ;
            if(i>1)
                params.sPOD.startValue = 'loadCoarsePsi' ;
            end
            for j=1:nrs
                if(i>1)
                    params.loadPsiFrom = fileNameSPOD{i-1,j} ;
                end
                params.nModes = r(j) ;
                fileNameSPOD{i,j} = ['./advectionDiffusionEq/DATA/sPODmodes_', datestr(date,'yyyy-mm-dd'),'_Nxi', num2str(Nxi(i)), '_r', num2str(r(j))] ;
                offlineError(i,j) = create_example_func(false, true, params, fileNameSPOD{i,j}) ;
                params.ADE.projectionMode = 'sPODROM' ;
                params.modeFile = fileNameSPOD{i,j} ;
                params.referenceSolution = fileNameADE ;
                onlineError(i,j) = create_example_func(true, false, params) ;
            end
            semilogy(r,offlineError(i,:), '--')
            Legend{(i-1)*2+1} = ['Nxi=', num2str(Nxi(i)), '-offline'] ;
            semilogy(r,onlineError(i,:))
            Legend{(i-1)*2+2} = ['Nxi=', num2str(Nxi(i)), '-online'] ;
            drawnow
            status2 = mkdir('sPOD','RESULTS') ;
            savefig(['./sPOD/RESULTS/fig_',datestr(date,'yyyy-mm-dd')])
            save(['./sPOD/RESULTS/data_',datestr(date,'yyyy-mm-dd')], 'Nxi', 'r', 'offlineError', 'onlineError')
        end
        simulationTime = toc ;
        legend(Legend) ;
    otherwise 
        error('Unknown figure.')
end