function sPODsystem = multiShiftReduceExtended(params, sPODsystem, qs, nModes)  

nTimeSteps = params.time.nTimeSteps                      ;
NxiExtended = computeNxiExtended(-sPODsystem.cs, params) ; % negative sign neutralizes the negative sign in the calling function subspaceDecompositionBySPODoptimization_extended

qsShifted = shiftMatrixExtended(cellfun(@transpose,sPODsystem.shiftMatrices,'UniformOutput',false), qs) ;   
qsShifted = reshape(qsShifted, NxiExtended, nTimeSteps)                               ; 
[U, S, V] = svds(qsShifted, nModes) ;

while(size(U,2)<nModes) % the reason for this while loop was a Matlab bug caused by svds returning not enough modes; normally this loop should be skipped
    k         = k+1                ;
    [U, S, V] = svds(qsShifted, k) ;
    if(k>min(nTimeSteps,NxiExtended))
        error('svds failed!')
    end
end

sPODsystem.U = U(:,1:nModes)                   ;
sPODsystem.V = V(:,1:nModes)                   ;
sPODsystem.S = sparse(S(1:nModes,1:nModes)) ;
