function shiftMatrices = shiftMatrixGenerator_extended(params, cs, NxiExtended, neededPointsOnTheLeft)

Nxi            = params.geometry.Nxi                  ;  
dxi            = params.geometry.dxi                  ; 
nCs            = length(cs)          ;

shiftMatrices    = cell(nCs, 1) ; 
diagonalIndexVec = NaN(1, 4)    ;
if(nargin<3)
    [NxiExtended, neededPointsOnTheLeft] = computeNxiExtended(-cs, params) ; % negative sign neutralizes the negative sign in the calling function subspaceDecompositionBySPODoptimization_extended
end

for i=1:nCs
    shiftLength         = cs(i)                                                                                               ;
    diagonalIndexVec(2)        = floor(shiftLength/dxi)                                                        ;
    diagonalIndexVec(1)        = diagonalIndexVec(2)-1                                                         ;
    diagonalIndexVec(3)        = diagonalIndexVec(2)+1                                                         ;  
    diagonalIndexVec(4)        = diagonalIndexVec(2)+2                                                         ;
    dxiWeight           = shiftLength/dxi-diagonalIndexVec(2)                                           ;
    shiftMatrices{i}    = spdiags(repmat((lagrange(dxiWeight))',Nxi,1), neededPointsOnTheLeft+diagonalIndexVec, Nxi, NxiExtended) ;
end